#!/usr/bin/perl -w
# DirPorts v0.5
# pkg.pl v0.5
# By Gianmarco Giovannelli (gmarco@giovannelli.it)
# an happy survivour of the :
# P-Day, C-Day, B-Day, E-Day, R-Day, lib.blabla-Day


use CGI qw(:standard :html3 :netscape);

require "addon.pl";

$path=param("dirname");
$file=param("file");
$index=0;
$timerstart= (times)[0];

($dirname,$portname)=split(/\//,$path);

$desc=`cat $basepath/$path/pkg-comment`;

open(Makefile,"$basepath/$dirname/$portname/Makefile");

while ($line = <Makefile>){
  $line=stripnp($line);

  if ($line =~ /^PORTNAME=/i){
    ($portname=$line) =~ s#.*=##s;   
  }

  if ($line =~ /^EXTRACT_SUFX=/i){
    ($suffix=$line) =~ s#.*=##s;
  }          

  if ($line =~ /^PKGNAME=/i){
    ($pkgname=$line) =~ s#.*=##s;
  } 

  if ($line =~ /^PORTVERSION=/i){
    (${PORTVERSION}=$line) =~ s#.*=##s;
     $portversion=${PORTVERSION};
  } 

  if ($line =~ /^MASTER_SITES=/i){
    ($mastersite=$line) =~ s#.*=##s;
      $mastersite = substr($mastersite,0,rindex($mastersite,"/"));	
  }                                      

  if ($line =~ /^DISTFILES=/i){
    ($line=$line) =~ s#.*= *##s;
      @distfiles=split(/ /,$line);
  }            
  
  if ($line =~ /^MAINTAINER=/i){
    ($maintainer=$line) =~ s#.*=##s;
  }                                      

  if ($line =~ /^DISTNAME=/i){
    ($distname=$line) =~ s#.*=##s;
  }                                      
  
  if ($line =~ /^BROKEN=/i){
    ($broken=$line) =~ s#.*=##s;
  }

  if ($line =~ /^DATE=/i){
    ($date=$line) =~ s#.*=##s;
  }

}




if ($mastersite =~ /_SUNSITE/){$mastersite="ftp://sunsite.unc.edu/pub/Linux/$dirname";}
if ($mastersite =~ /_XCONTRIB/){$mastersite="ftp://crl.dec.com/pub/X11/contrib/$dirname";}
if ($mastersite =~ /_GNU/){$mastersite="ftp://prep.ai.mit.edu/pub/gnu/$dirname";}
if ($mastersite =~ /_PERL_CPAN/){$mastersite="ftp://ftp.digital.com/pub/plan/perl/CPAN/modules/by-module/$dirname";}
if ($mastersite =~ /_TEX_CTAN/){$mastersite="ftp://ftp://ftp.cdrom.com/pub/tex/ctan/$dirname";}
if ($mastersite =~ /_KDE/){$mastersite="ftp://ftp.us.kde.org/pub/kde/$dirname";}
if ($mastersite eq "" || $mastersite =~ /_LOCAL/) {$mastersite = "ftp://ftp.freebsd.org/pub/FreeBSD/distfiles";}

if ($maintainer eq "") {
  $maintainer = "ports\@freebsd.org";
}

if ($suffix eq "" || $suffix=~ /\$\{EXTRACT_SUFX\}/) {
  $suffix = ".tar.gz";
}

if ($broken eq "") {
  $broken = "No";
}

if ($pkgname eq ""){
  $pkgname=$portname."-".$portversion;
  ${PKGNAME}="${PKGNAMEPREFIX}.${PORTNAME}.${PKGNAMESUFFIX}.-.${PORTVERSION}";
}

$portname=convmacro($portname);
$pkgname=convmacro($pkgname);
$basepkgname = substr($pkgname,0,rindex($pkgname,"-"));	

$pkgnameinst = basename(glob("/var/db/pkg/$basepkgname*"));
if ($pkgnameinst eq ""){
  $pkgnameinst="Not installed";
}


if ($distfiles[0] eq ""){
  $distfiles[0] = $portname.$suffix;
}


for ($index=0; $index<@distfiles; $index++){

  $distfiles[$index]=convmacro($distfiles[$index]);
 
  if  (-e "$basepath/distfiles/$distfiles[$index]"){
	$distfilepresent="Yes" ;
  } else {
	$distfilepresent="No" ;
  }	

  push(@distlines,td(font({-size=>$pfs, -face=>$fontface},b("Distfile"))).td(font({-size=>$dfs, -face=>$fontface},a({href=>$mastersite."/".$distfiles[$index]},$distfiles[$index]))).td(font({-size=>$dfs, -face=>$fontface},b("In distfiles dir ? ").$distfilepresent)));
}


# Begin Page generation

print header(), 
  start_html(-title =>"Port of $portname \($dirname\)", -bgcolor=>$bgcolor),
  basefont({-size=>$bfs, -face=>$fontface}),
  
  h1("The FreeBSD Ports Collection: $dirname"), 
  center(h2("$pkgname")), 
  center(table({ -border=>$tableborder, -width=>"90%"},
	       Tr(
		  td(font({-size=>$pfs, -face=>$fontface},b("Description"))),
		  td({ -colspan=>"2"}, font({-size=>$dfs, -face=>$fontface},$desc))),
	       Tr(
		  td(font({-size=>$pfs, -face=>$fontface},b("Mantainer"))),
		  td(font({-size=>$dfs, -face=>$fontface},a({href=>"mailto:$maintainer"},$maintainer))),
		  td(font({-size=>$dfs, -face=>$fontface},b("Broken ? ").$broken)),
		 ),
	       Tr(
		  td(font({-size=>$pfs, -face=>$fontface},b("PkgName"))),
		  td(font({-size=>$dfs, -face=>$fontface},$pkgname)),
		  td(font({-size=>$dfs, -face=>$fontface},b("Installed ? ").$pkgnameinst)),
		 ),
		
	       Tr(        
		  td(font({-size=>$pfs, -face=>$fontface},b("Main Home Page"))),
		  td(font({-size=>$dfs, -face=>$fontface},a({href=>"$mastersite"},$mastersite))),
		  td(),
		 ),
	       
	       Tr([@distlines])));
print p();
print center(table({-width=>"95%"},
		   Tr(
		      td(font({-size=>$pfs, -face=>$fontface},
			      a({href=>"./index.pl"},"Return to main page"))),
		      td(font({-size=>$pfs, -face=>$fontface},
			      a({href=>"./portdir.pl?dirname=$dirname"},"Return to $dirname page"))),
		      td(font({-size=>$pfs, -face=>$fontface},
			      a({href=>"./pkg.pl?file=Makefile&dirname=".CGI->escape($path)},"View Makefile"))),
		      td(font({-size=>$pfs, -face=>$fontface},
			      a({href=>"./pkg.pl?file=Longdesc&dirname=".CGI->escape($path)},"View Long Desc"))),
		      td(font({-size=>$pfs, -face=>$fontface},
			      a({href=>"./pkg.pl?dirname=".CGI->escape($path)},"Close View"))),
		     )));  

print hr();


if ($file ne ""){
  if ($file eq "Makefile"){ 
    print center(table {-border=>'1'},(Tr(td(font({-size=>$dfs, -face=>$fontface},pre((`cat $basepath/$path/Makefile`)))))));
  }
  if ($file eq "Longdesc"){
    print center(table {-border=>'1'},(Tr(td(font({-size=>$dfs, -face=>$fontface},pre((`cat $basepath/$path/pkg-descr`)))))));
  }
}

print end_html();                                                 
